libsmb: Fix CID 1465860 Control flow issues (DEADCODE)
[samba.git] / selftest / in_screen
1 #!/usr/bin/env bash
2
3 export TMPDIR="$SELFTEST_TMPDIR"
4
5 SERVERNAME="$ENVNAME"
6 [ -z "$SERVERNAME" ] && SERVERNAME="base"
7 basedir=$TMPDIR
8
9 [ -r $basedir/$SERVERNAME.pid ] && {
10     for i in {2..100}; do
11         if [ ! -r "$basedir/${SERVERNAME}-$i.pid" ]; then
12             SERVERNAME="${SERVERNAME}-$i"
13             break
14         fi
15     done
16 }
17
18 rm -f $basedir/$SERVERNAME.{launch,log,parent.pid,pid,status}
19
20 # set most of the environment vars we have in the screen session too
21 _ENV=""
22 printenv |
23   egrep -v '^TERMCAP|^WINDOW|^SHELL|^STY|^SHLVL|^SAMBA_VALGRIND|\$' |
24   egrep '^[A-Z]' |
25   sed "s/\(^[^=]*=\)\(.*\)/export \1'\2'/g" > $basedir/$SERVERNAME.vars
26
27 cat <<EOF > $basedir/$SERVERNAME.launch
28 cd $PWD
29  echo \$\$ > $basedir/$SERVERNAME.pid
30  . $basedir/$SERVERNAME.vars
31  echo "\$(date) starting $SERVERNAME" >> $basedir/$SERVERNAME.log
32  $@
33  echo \$? > $basedir/$SERVERNAME.status
34  read parent < $basedir/$SERVERNAME.parent.pid
35  kill \$parent
36 EOF
37 pid=$$
38
39 cleanup() {
40     trap "exit 1" SIGINT SIGTERM SIGPIPE
41     [ -r $basedir/$SERVERNAME.status ] && {
42         read status < $basedir/$SERVERNAME.status
43         echo "$(date) samba exited with status $status" >> $basedir/$SERVERNAME.log
44         exit $status
45     }
46
47     case $ENVNAME in
48         *.nmbd|*.smbd|*.winbindd|*.samba)
49             kill $(cat $basedir/../"${ENVNAME%\.*}"/pid/"${ENVNAME##*\.}".pid)
50             ;;
51     esac
52
53     read pid < $basedir/$SERVERNAME.pid
54     echo "$(date) Killing samba pid $pid from $$" >> $basedir/$SERVERNAME.log
55     if [ "$pid" = "$$" ]; then
56         exit 1
57     fi
58     kill -9 $pid 2>&1
59     exit 1
60 }
61
62 echo $$ > $basedir/$SERVERNAME.parent.pid
63 trap cleanup SIGINT SIGTERM SIGPIPE
64
65 if [[ "$TMUX" ]]; then
66     TMUX_CMD=tmux
67     if [[ $TMUX = *tmate* ]]; then
68         TMUX_CMD=tmate
69     fi
70
71     $TMUX_CMD new-window -n test:$SERVERNAME "bash $basedir/$SERVERNAME.launch"
72
73     # tmux seems to lag a bit for new sessions. Don't create them too
74     # quickly one after another
75     sleep .1
76 else
77     screen -r -X screen -t test:$SERVERNAME bash $basedir/$SERVERNAME.launch
78 fi
79 echo "$(date) waiting in $$" >> $basedir/$SERVERNAME.log
80 read stdin_var
81 echo "$(date) EOF on stdin" >> $basedir/$SERVERNAME.log
82
83 case $ENVNAME in
84     *.nmbd|*.smbd|*.winbindd|*.samba)
85         kill $(cat $basedir/../"${ENVNAME%\.*}"/pid/"${ENVNAME##*\.}".pid)
86         ;;
87 esac
88
89 read pid < $basedir/$SERVERNAME.pid
90 echo "$(date) killing $pid" >> $basedir/$SERVERNAME.log
91 kill $pid 2> /dev/null
92 echo "$(date) exiting" >> $basedir/$SERVERNAME.log
93 exit 0